Subject: Re: Project idea: strbuf allocation modes

From: Junio C Hamano <[email-masked]>
Date: Fri, 18 Apr 2014 17:55:19 -0700

Michael Haggerty <[email-masked]> writes:

> On 04/18/2014 07:21 PM, Junio C Hamano wrote:
>> Michael Haggerty <[email-masked]> writes:
>> 
>>> The Idea
>>> ========
>>>
>>> I would like to see strbuf enhanced to allow it to use memory that it
>>> doesn't own (for example, stack-allocated memory), while (optionally)
>>> allowing it to switch over to using allocated memory if the string grows
>>> past the size of the pre-allocated buffer.
>> 
>> I'd like to see these characteristics, but I would want to see that
>> this is done entirely internally inside the strbuf implementation
>> without any API impact, other than the initialisation.  I do not
>> ...
>
> I think that's exactly what I described.  The only thing that would have
> to change in the strbuf behavior (aside from initialization) is that a
> buffer-growing operation might die if the string would grow outside of
> the bounds of the existing buffer when STRBUF_FIXED_MEMORY is set.

Yup, we are in agreement ;-)

More seriously, sorry for sounding as if I was objecting. I should
have edited s/but/and/ before sending my response out.

Thanks.